<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Sound Manager: **Sound Manager Application Guide**</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Sound Manager
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('md__r_1__sound_manager_binding_doc__application_guide.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">**Sound Manager Application Guide** </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><div align="right">Revision: 0.2Beta</div> <div align="right">TOYOTA MOTOR CORPORATION</div> <div align="right">Advanced Driver Information Technology</div> <div align="right">2nd/Oct/2017</div><hr/>
<h2>**Table of content**</h2>
<ul>
<li><a href="#Target\ reader\ of\ this\ document">Target reader of this document</a></li>
<li><a href="#Overview">Overview</a></li>
<li><a href="#Getting\ Start">Getting Start</a><ul>
<li><a href="#Supported\ environment">Supported environment</a></li>
<li><a href="#Build">Build</a></li>
<li><a href="#Configuring">Configuring</a></li>
<li><a href="#Additional\ work">Additional work</a></li>
<li><a href="#How\ to\ call\ Sound\ Manager\ APIs\ from\ your\ Application?">How to call Sound Manager's APIs from your Application?</a></li>
</ul>
</li>
<li><a href="#Supported\ usecase">Supported usecase</a></li>
<li><a href="#Software\ Architecture">Software Architecture</a></li>
<li><a href="#API\ reference">API reference</a><ul>
<li><a href="#APIs">APIs</a></li>
<li><a href="#Events">Events</a></li>
</ul>
</li>
<li><a href="#Sequence">Sequence</a><ul>
<li><a href="#StartUp">StartUp</a></li>
<li><a href="#Registration">Registration</a></li>
<li><a href="#Request\ Sound\ Right">Request Sound Right</a></li>
<li><a href="#Connect\ Sound\ Route">Connect Sound Route</a></li>
<li><a href="#Start\ Sound\ Streaming">Start Sound Streaming</a></li>
<li><a href="#Stop\ Sound\ Streaming">Stop Sound Streaming</a></li>
<li><a href="#Disconnect\ Sound\ Route">Disconnect Sound Route</a></li>
<li><a href="#Change\ Volume">Change Volume</a></li>
<li><a href="#Set\ Mute\ State">Set Mute State</a></li>
<li><a href="#Release\ Sound\ Right">Release Sound Right</a></li>
<li><a href="#Audio\ Domain">Audio Domain</a></li>
</ul>
</li>
<li><a href="#Sample\ code">Sample code</a></li>
<li><a href="#Limitation">Limitation</a></li>
</ul>
<hr/>
<h2>**Target reader of this document**</h2>
<p>Application developer whose software uses sound output.</p>
<hr/>
<h2>**Overview**</h2>
<p>The sound manager is the service which provides <b>sound-right management</b> for multiple sound sources. This service based on GENIVI Audio Manager, and this package contains service binder and library for API calling. The reason why this service based on GENIVI Audio Manager is because the sound manager supports highly strong and flexible sound-right management function.</p>
<p>In order to understand, the below figure shows the one of typical usecases. In this example, there are four sound mode.</p><ol type="1">
<li>Audio Off</li>
<li>Media Player</li>
<li>Tel (Ring and talking)</li>
<li>TTS (Text To Speech; typically it's used by Navigation sound) <div class="image">
<img src="parts/typical-usecase.png" alt="Figure: Typical usecase"/>
</div>
</li>
</ol>
<p>The important points are:</p><ul>
<li><b>There is a priority for each sound source.</b> In this example, "Tel" and "TTS" is stronger than "MediaPlayer". Therefore when the system got incoming call, all four outputs of MediaPlayer are muted automatically by Sound Manager. And in this timing, Sound Manager will issue the event to Media Player, then Media Player can stop the music. (Because depends on OEM's requirement, "Stop" is required, not "Mute".) "Tel" and "TTS" have the same priority. So if TTS event happened on talking, each sound will output from independent speaker. If on-hook button is touched, Sound Manager will resume previous sound mode. In this example, basically it's MediaPlayer sound. But if TTS still playing, three speaker will output MediaPlayer sound but one speaker will continue to output TTS sound.</li>
<li><b>Sound mode transition should be done by Sound Manager not Applications.</b> Actually application cannot recognize all sound source and its priority, so some centerized manager is required. Sound Manager provides this function. Sound Manager has a database for usecase and priority and in line with this policy Sound Manager controls proper sound mode.</li>
</ul>
<p>The below links show the example of Sound/Window mode transition.</p><ul>
<li><a class="el" href="_display___audio___transition1_8md.html">Single window application</a> This transition assumes target IVI system support only one window on screen. It's a similar transition to CES2017 demo.</li>
<li><p class="startli"><a class="el" href="_display___audio___transition2_8md.html">Dual window application</a> This transition assumes target IVI system support two window (split screen) on screen.</p>
<p class="startli">Of course user can customize shortcut menu, but since it's too many states so this example limits shortcut menu as "Home", "MediaPlayer", "HVAC" and "Navigation".</p>
</li>
</ul>
<hr/>
<h2>**Getting Start**</h2>
<h3>**Supported environment**</h3>
<table class="doxtable">
<tr>
<th align="left">Item </th><th align="left">Description  </th></tr>
<tr>
<td align="left">AGL version </td><td align="left">Daring Dab </td></tr>
<tr>
<td align="left">Hardware </td><td align="left">Renesas R-Car Starter Kit Pro(M3) </td></tr>
</table>
<h3>**Build**</h3>
<p>You can make Sound Manager object files by the following two stage operations.</p>
<p><b>Download recipe</b> If repo is already done, please start with git clone </p><div class="fragment"><div class="line">$ mkdir WORK</div><div class="line">$ cd WORK</div><div class="line">$ repo init -b dab -m dab_4.0.0_xml -u https://gerrit.automotivelinux.org/gerrit/AGL/AGL-repo</div><div class="line">$ repo sync</div><div class="line">$ git clone https://gerrit.automotivelinux.org/gerrit/staging/meta-hmi-framework</div></div><!-- fragment --><p>Then you can get the following recipe.</p><ul>
<li><code>meta-hmi-framework/agl-service-soundmanager-2017</code></li>
</ul>
<p><b>Bitbake</b> </p><div class="fragment"><div class="line">$ source meta-agl/scripts/aglsetup.sh -m m3ulcb agl-demo agl-devel agl-appfw-smack hmi-framework</div><div class="line">$ bitbake agl-service-soundmanager-2017</div></div><!-- fragment --><hr/>
<h3>**Configuring**</h3>
<p>To use Sound Manager API, an application shall paste the following configuration definition into "config.xml" of application. </p><div class="fragment"><div class="line">&lt;feature name=&quot;urn:AGL:widget:required-api&quot;&gt;</div><div class="line">    &lt;param name=&quot;soundmanager&quot; value=&quot;ws&quot; /&gt;</div><div class="line">&lt;/feature&gt;</div></div><!-- fragment --><hr/>
<h3>**Additional work**</h3>
<p><b>Add Policy file</b></p>
<p>To add Sound Manager Domain into policy, put the following file to /etc/audiomanager/control.</p>
<p><code>soundmanager/conf/audiomanager-config-sample/configuration.xml</code></p>
<p><b>Remove Module router of Pulse Audio</b></p>
<p>Because the module rounter access to Audio manager for getting sound right instead of application in CES2017, after you changed your application code for Sound manager, you should remove the module router. To do this, you have to comment out line.143 of /etc/pulse/default.pa as below.</p>
<div class="fragment"><div class="line">.ifexists module-router.so</div><div class="line">#load-module module-router</div><div class="line">.endif</div></div><!-- fragment --><hr/>
<h3>**How to call Sound Manager APIs from your Application?**</h3>
<p>Sound Manager provides a library which is called "libsoundmanager". This library provides function style API calling interface. So you should include <a class="el" href="libsoundmanager_8hpp.html">libsoundmanager.hpp</a> headerfile, and should link this library. Please also refer sample application and template.</p>
<p>See also our <a href="#Sample\ code">Sample code</a>.</p>
<p><br />
</p>
<hr/>
<h2>**Supported usecase**</h2>
<ol type="1">
<li>Active source change<ul>
<li>When user choose different audio source with current one, IVI system stop or pause current source and activate new one.</li>
<li>When user connect external device e.g. iPhone, USB memory IVI system change active source automatically to connected one.</li>
</ul>
</li>
<li>Active source locking<ul>
<li>When user is in phone call, IVI restrict to change active source.</li>
</ul>
</li>
<li>Interrupt source mixing<ul>
<li>When car close to cross road IVI system reduce the volume of current source and mix with interrupt source e.g. Navigation Guidance.</li>
</ul>
</li>
<li>Volume change<ul>
<li>User can change the volume of active source or sink.</li>
<li>When user change volume during interruption e.g. Navigation Guidance, IVI system change its volume temporary or permanently.</li>
</ul>
</li>
<li>Mute/unmute<ul>
<li>User can mute/unmute current active source.</li>
</ul>
</li>
<li>Volume management<ul>
<li>When user change active source, IVI system mute/unmute to avoid distortion of sound.</li>
</ul>
</li>
<li>Volume acceleration<ul>
<li>When road noise is increased by speed, IVI system automatically change the volume of active source.</li>
</ul>
</li>
<li>Routing sound<ul>
<li>System needs to route sound stream to proper zones. (driver zone, passenger zone, rear seat zone)</li>
</ul>
</li>
</ol>
<p><a href="https://wiki.automotivelinux.org/eg-ui-graphics-req-audiorouting">See also this page</a></p>
<hr/>
<h2>**Software Architecture**</h2>
<p>The architecture of Sound Manager is shown below. Sound Manager is the service designed to be used by multiple applications. Therefore Sound Manager framework consists on two binder layers. Please refer the following figure. The upper binder is for application side security context for applications. The lower binder is for servide side security context. Usually application side binder has some business logic for each application, so the number of binders depend on the number of applications which use Sound Manager. On the other hand, regarding lower binder there is only one module in the system. This binder receives all messages from multiple applications (in detail, it comes from upper layer binder).</p>
<p>The communication protocols between libsoundmanager and upper binder, upper binder and lower binder, lower binder (soundmanager-binding) and AudioManager are WebSocket.</p>
<div class="image">
<img src="parts/software-stack.png" alt="software-stack.png"/>
</div>
<hr/>
<h2>**API reference**</h2>
<p>"libsoundmanager" and "soundmanager_binding" provides several kinds of APIs, and these APIs basically correspond to GENIVI Audio Manager API. (Some APIs are Sound Manager original functions.)</p>
<p>For understanding, GENIVI Audio Manager stands for one core module and three plug-ins.</p><ol type="1">
<li>AudioManagerDaemon This is a core module of Audio Manager.</li>
<li>AudioManagerCommandPlugin This is a command interface for Audio Manager.</li>
<li>AudioManagerController This plug-in can be used for sound-right management.</li>
<li>AudioManagerRountingPlugin This plug-in abstracts the hardware and software. And sometimes there may be multiple plug-ins.</li>
</ol>
<p>*) <a href="http://docs.projects.genivi.org/AudioManager/audiomanagercomponentspage.html">See also GENIVI AudioManager Components</a></p>
<div class="image">
<img src="parts/am-component.png" alt="See also GENIVI AudioManager Components"/>
</div>
<p> (This figure was copied from GENIVI Web page.)</p>
<h3>**APIs**</h3>
<ul>
<li>[init(int port, const std::string&amp; token)]()</li>
<li><a href="http://docs.projects.genivi.org/AudioManager/a00053.html#acadce23459d94cec496d17700cbde230">registerSource(const std::string&amp; sourceName)</a></li>
<li><a href="http://docs.projects.genivi.org/AudioManager/a00033.html#a62d8f5aee1e601d59f993c5a5561e234">connect(int sourceID, int sinkID)</a></li>
<li><a href="http://docs.projects.genivi.org/AudioManager/a00033.html#a62d8f5aee1e601d59f993c5a5561e234">connect(int sourceID, const std::string&amp; sinkName = "default")</a></li>
<li><a href="http://docs.projects.genivi.org/AudioManager/a00033.html#aa24d0146f4e3c75e02d6c0152e246da1">disconnect(int connectionID)</a></li>
<li><a href="http://docs.projects.genivi.org/AudioManager/a00053.html#a11f6b0378a50296a72107d6a1fa7ec21">ackSetSourceState(int sourceID, int handle, int errno)</a></li>
<li><a href="api-ref/html/class_lib_soundmanager.html#a8b51e9891813cb62dd12109c017ad106">LibSoundmanager ()</a></li>
<li>[set_event_handler(enum EventType_AsyncSetSourceState et, handler_asyncSetSourceState f)]()</li>
<li>[register_callback( void (<em>event_cb)(const std::string&amp; event, struct json_object</em> event_contents), void (<em>reply_cb)(struct json_object</em> reply_contents), void (<em>hangup_cb)(void) = nullptr)]()</em></li>
<li><em>[register_callback( void (*reply_cb)(struct json_object</em> reply_contents), void (*hangup_cb)(void) = nullptr)]()</li>
</ul>
<p>The below APIs will be available at RC2.</p>
<ul>
<li><a href="http://docs.projects.genivi.org/AudioManager/a00033.html#a6d47bc67473d75495260abe8c666fc7e">setVolume (const am_sinkID_t sinkID, const am_mainVolume_t volume)</a></li>
<li><a href="http://docs.projects.genivi.org/AudioManager/a00033.html#ad7a4c1fe5a2ecfaae5484a14d8820e58">volumeStep (const am_sinkID_t sinkID, const int16_t volumeStep)</a></li>
<li><a href="http://docs.projects.genivi.org/AudioManager/a00033.html#afae22041843c5349be16a6593d3ebb9c">setSinkMuteState (const am_sinkID_t sinkID, const am_MuteState_e muteState)</a></li>
<li><a href="http://docs.projects.genivi.org/AudioManager/a00033.html#a59d10a7178e3227d0b8f415308c71179">getListMainConnections (std::vector&lt; am_MainConnectionType_s &gt; &amp;listConnections)</a></li>
<li><a href="http://docs.projects.genivi.org/AudioManager/a00053.html#a1dd1b89cccffeaafb1a3c11cebd7e48c">confirmRoutingReady (const uint16_t handle, const am_Error_e error)</a></li>
</ul>
<h3>**Events**</h3>
<ul>
<li>[EventType_AsyncSetSourceState]()</li>
</ul>
<p>The below Events will be available at RC2.</p>
<ul>
<li><a href="http://docs.projects.genivi.org/AudioManager/a00034.html#a69ada9e19c65c1d078d8a5f473d08586">EventType_NewMainConnection</a></li>
<li><a href="http://docs.projects.genivi.org/AudioManager/a00034.html#aa3b5906bcf682cff155fb24d402efd89">EventType_RemovedMainConnection</a></li>
<li><a href="http://docs.projects.genivi.org/AudioManager/a00034.html#a32aa8ab84632805a876e023a7aead810">EventType_MainConnectionStateChanged</a></li>
<li><a href="http://docs.projects.genivi.org/AudioManager/a00034.html#a4494fdd835137e572f2cf4a3aceb6ae5">EventType_VolumeChanged</a></li>
<li><a href="http://docs.projects.genivi.org/AudioManager/a00034.html#a6068ce59089fbdc63aec81e778aba238">EventType_SinkMuteStateChanged</a></li>
<li><a href="http://docs.projects.genivi.org/AudioManager/a00054.html#a7a4d410e30df0e8240d25a57e3c72c6b">EventType_setRoutingReady</a></li>
<li><a href="http://docs.projects.genivi.org/AudioManager/a00054.html#a8a81297be9c64511e27d85444c59b0d6">EventType_asyncConnect</a></li>
<li><a href="http://docs.projects.genivi.org/AudioManager/a00054.html#ab02d93d54ee9cd98776a3f2d274ee24d">EventType_asyncSetSourceState</a></li>
<li><a href="http://docs.projects.genivi.org/AudioManager/a00054.html#a93ae95515730eb615ab5dfc1316d7862">EventType_asyncDisconnect</a></li>
</ul>
<hr/>
<h2>**Sequence**</h2>
<h3>**StartUp**</h3>
<div class="image">
<object type="image/svg+xml" data="parts/seq_startup.svg" alt="seq_startup.png"></object>
</div>
<h3>**Registration**</h3>
<div class="image">
<object type="image/svg+xml" data="parts/seq_registration.svg" alt="seq_registration.png"></object>
</div>
<h3>**Request Sound Right**</h3>
<div class="image">
<object type="image/svg+xml" data="parts/seq_requestsoundmode.svg" alt="seq_requestsoundmode.png"></object>
</div>
<h3>**Connect Sound Route**</h3>
<div class="image">
<object type="image/svg+xml" data="parts/seq_connectsoundroute.svg" alt="seq_connectsoundroute.png"></object>
</div>
<h3>**Start Sound Streaming**</h3>
<div class="image">
<object type="image/svg+xml" data="parts/seq_startsoundstreaming.svg" alt="seq_startsoundstreaming.png"></object>
</div>
<h3>**Stop Sound Streaming**</h3>
<div class="image">
<object type="image/svg+xml" data="parts/seq_stopsoundstreaming.svg" alt="seq_stopsoundstreaming.png"></object>
</div>
<h3>**Disconnect Sound Route**</h3>
<div class="image">
<object type="image/svg+xml" data="parts/seq_disconnectsoundroute.svg" alt="seq_disconnectsoundroute.png"></object>
</div>
<h3>**Change Volume**</h3>
<div class="image">
<object type="image/svg+xml" data="parts/seq_changevolume.svg" alt="seq_changevolume.png"></object>
</div>
<h3>**Set Mute State**</h3>
<div class="image">
<object type="image/svg+xml" data="parts/seq_setmutestate.svg" alt="seq_setmutestate.png"></object>
</div>
<h3>**Release Sound Right**</h3>
<div class="image">
<object type="image/svg+xml" data="parts/seq_releasesoundmode.svg" alt="seq_releasesoundmode.png"></object>
</div>
<hr/>
<h3>**Audio Domain**</h3>
<p>One of the most important concept of Audio Manager is Audio Domain. To use GENIVI Audio Manager based system, it may be better to understand this concept. The below document should bring good understanding.</p>
<p><a href="http://events.linuxfoundation.org/sites/events/files/slides/AGL_AMM_presentation_A01.pdf">GENIVI Audio Manager: Generic Controller Plug-in</a></p>
<p>Although strongly recommended to read whole pages, but you can get quick understanding by page.10 to 14.</p>
<h1>**Sample code**</h1>
<p>You can find sample implementation of Sound Manager as below.</p><ul>
<li><code>apps/agl-service-homescreen-2017/sample/template</code></li>
<li><code>apps/agl-service-homescreen-2017/sample/radio</code></li>
<li><code>apps/agl-service-homescreen-2017/sample/mediaplayer</code></li>
</ul>
<h1>**Limitation**</h1>
<ul>
<li>Minimum APIs and Events are prepared for RC1, the following APIs will be available for RC2.<ul>
<li>setVolume</li>
<li>volumeStep</li>
<li>setSinkMuteState</li>
<li>getListMainConnections</li>
<li>confirmRoutingReady</li>
<li>EventType_NewMainConnection</li>
<li>EventType_RemovedMainConnection</li>
<li>EventType_MainConnectionStateChanged</li>
<li>EventType_VolumeChanged</li>
<li>EventType_SinkMuteStateChanged</li>
<li>EventType_setRoutingReady</li>
<li>EventType_asyncConnect</li>
<li>EventType_asyncSetSourceState</li>
<li>EventType_asyncDisconnect </li>
</ul>
</li>
</ul>
</div></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.13 </li>
  </ul>
</div>
</body>
</html>
